"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCommands = void 0;
/**
 * Converts generateMiniLogoCmds to an array of commands
 * @param commands the output of generateMiniLogoCmds
 * @returns an array of commands
 */
function getCommands(commands) {
    let result = [];
    commands.forEach((command) => {
        switch (command.cmd) {
            case 'penUp':
                result.push({ name: 'penUp', args: undefined });
                break;
            case 'penDown':
                result.push({ name: 'penDown', args: undefined });
                break;
            case 'move':
                result.push({ name: 'move', args: { x: command.x, y: command.y } });
                break;
            case 'color':
                result.push({ name: 'color', args: { color: command.color, r: command.r, g: command.g, b: command.b } });
                break;
        }
    });
    return result;
}
exports.getCommands = getCommands;
//# sourceMappingURL=minilogo-actions.js.map